--[[ 
	Skrypt obsugujcy bramk SMS na stronie Miasto Plusa, dla wtyczki SMS.dll do programu Konnekt
	
	Autor skryptu:
		mls (mls@o2.pl)
	Poprawki:
		shw (2.0.0, 2.0.1)
		ve (red.guy@gazeta.pl) (2.1)
		anboo (anbu@o2.pl) (2.2.x)
		zbygumil (zbygumil@interia.pl) (2.3)

	Odpowiedzialno za wykorzystywanie skryptu ponosi uytkownik.

	Wymaga obecnoci pliku const.lua w katalogu ze skryptem!
--]]     

include("const.lua"); 

function plus_send(SMS) 
	--- zmie na 1 by wczy debug
	DEBUG = 0;

	--- ustawienie zmiennych
	SMS.to = preg_matchReturn("/\\d{9}$/" , SMS.to); 
	SMS.msg = hidePL(SMS.msg);

	--- sprawdzenie poprawnoci danych
	if (SMS.plusUser == "" or SMS.plusPass == "") then 
		setError("Nie wpisae loginu lub hasa");
		alert("Nie wpisae loginu lub hasa w konfiguracji");
		return;
	end;
	
	--- USTAWIENIA SMSA
	
	--- waznosc
	if (SMS.plusWaz == "8") then SMS.plusWaz = "8"; elseif (SMS.plusWaz == "24") then SMS.plusWaz = "24"; elseif(SMS.plusWaz == "72") then SMS.plusWaz = "72"; else SMS.plusWaz = "48"; end;
	--- powiadomienie
	if (SMS.plusPow == "1") then SMS.plusPowI = "10"; elseif(SMS.plusPow == "2") then SMS.plusPowI = "30"; else SMS.plusPowI = "0"; end;
	--- flash
	if (SMS.plusFlash == "1") then SMS.plusFlash = "1"; else SMS.plusFlash = "0"; end;
	--- archiwalizacja
	if (SMS.plusArch == "1") then SMS.plusArch = "1"; else SMS.plusArch = "0"; end;
	--- czas
	 --- dzien

--- tutaj czasowka

	plusWhen = {}; --- inicjacja tablicy
	SMS.plusKiedy = "-1"; --- natychmiast

	if (preg_match("#dzi.#si",SMS.from,plusWhen) > 0) then SMS.plusKiedy = "0"; end;
	if (preg_match("#jutro#si",SMS.from,plusWhen) > 0) then SMS.plusKiedy = "1"; end;
	if (preg_match("#pojutrze#si",SMS.from,plusWhen) > 0) then SMS.plusKiedy = "2"; end;
	if (preg_match("#3 dni#si",SMS.from,plusWhen) > 0) then SMS.plusKiedy = "3"; end;
	if (preg_match("#4 dni#si",SMS.from,plusWhen) > 0) then SMS.plusKiedy = "4"; end;
	if (preg_match("#5 dni#si",SMS.from,plusWhen) > 0) then SMS.plusKiedy = "5"; end;
	if (preg_match("#6 dni#si",SMS.from,plusWhen) > 0) then SMS.plusKiedy = "6"; end;
	if (preg_match("#(7 dni|tydzie.)#si",SMS.from,plusWhen) > 0) then SMS.plusKiedy = "7"; end;

	--- godzina
	
	SMS.godzina = "0";
	SMS.minuta = "0"; 

	if (preg_match("#(\\d{1,2}):(\\d{2})#",SMS.from) > 0) then
		if(SMS.plusKiedy == "-1") then SMS.plusKiedy = "0"; plusWhen[0] = "dzis"; end;
		czas2 ,godzina, minuta = preg_matchReturn("#(\\d{1,2}):(\\d{2})#",SMS.from);

		SMS.godzina = preg_replace("#(0)(\\d{1})#","$2",godzina);
		SMS.minuta = preg_replace("#(0)(\\d{1})#","$2",minuta);

		SMS.godzina = preg_replace("#24#","0",godzina); --- w przypadku podania 24, a nie 00

	elseif(SMS.plusKiedy ~= "-1") then --- nie podano godziny, ale podano kiedy wysa
	
		data , rok , miesiac , dzien, godzina, minuta, sekunda = preg_matchReturn("#(\\d{2})-(\\d{1,2})-(\\d{1,2}) (\\d{1,2}):(\\d{1,2}):(\\d{1,2})#" , os.date()); 
		SMS.godzina = preg_replace("#(0)(\\d{1})#","$2",godzina);
		SMS.minuta = preg_replace("#(0)(\\d{1})#","$2",minuta);
		
		SMS.minuta = SMS.minuta + SMS.plusOpoz;

		if(SMS.minuta >= 60) then --- przekroczenie czasu
		 SMS.godzina = SMS.godzina + 1;
		 SMS.minuta = SMS.minuta - 60;
		else
		 SMS.godzina = SMS.godzina + 0; --- dodane, bo wywalalo przy ifie blad typu (porownianie stringu i inta)
		end;

		if(SMS.godzina >= 23) then --- przekroczenie czasu
		 SMS.plusKiedy = SMS.plusKiedy + 1;
		 SMS.godzina = SMS.godzina - 23;
		end;

		minuta = preg_replace("#$(\\d{1})#","0$1",SMS.minuta);
		godzina = preg_replace("#$(\\d{1})#","0$1",SMS.godzina);

	end;

	--- dodatkowe info
	if(SMS.plusExInfo == "1") then 
	 setInfo("Wiadomo bdzie wana przez "..SMS.plusWaz.." godzin");
	  if (SMS.plusPow == "1") then powiad = "www" elseif(SMS.plusPow == "2") then powiad = "sms" else powiad = "brak" end;
	 setInfo("Wabrany rodzaj powiadomienia: "..powiad);
	  if(SMS.plusFlash == "1") then 	setInfo("Wiadomo jako Flash SMS"); end;
	  if(SMS.plusArch == "1") then 	setInfo("Wiadomo zostanie zarchiwalizowana"); end;
	 setInfo("Cakowita dugo SMS'a to: "..string.len(SMS.plusUser..SMS.msg));
	 setInfo("Zostanie wysanych "..math.ceil((string.len(SMS.plusUser..SMS.msg)/150)).." SMS'w");
	  if(SMS.plusKiedy ~= "-1") then
	   setInfo("Zostanie wysane z oponieniem (za): ".. plusWhen[0]);
	   setInfo("O godzinie: ".. godzina .. ":" .. minuta);
	  end;
	end;

	--- utworzenie sesji poczenia
	hSession = InternetOpen("Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; Konnekt SMS)"); 
	if hSession == 0 then setError("Bd tworzenia poczenia."); return; end;

	--- poczenie ze stron
	setInfo("cz: www.miastoplusa.pl...");
	hConnect = InternetConnect(hSession, "www.miastoplusa.pl", 80, "");
	if hConnect == 0 then setError("Bd poczenia ze stron!"); return; end;

	--- pobranie cookies
	setInfo("Pora na ciacha... ;)");
	hRequest = HttpOpenRequest(hConnect, "GET", "/", "");
	HttpSendRequest(hRequest, "", "");
	if (DEBUG) then txt = InternetReadFile(hRequest); plik=io.open("temp\\plus_cookie.txt" , "wt"); if (plik) then plik:write(txt); plik:close(plik); end; end;
	InternetCloseHandle(hRequest);

	--- zalogowanie do serwisu
	setInfo("Loguj do Miasta Plusa...");
	hRequest = HttpOpenRequest(hConnect, "POST", "/auth/LoginCitizen.do", "http://www.miastoplusa.pl", INTERNET_FLAG_NO_AUTO_REDIRECT);
	if hRequest == 0 then setError("Bd logowania!"); return; end;
	data = "login="..urlEncode(SMS.plusUser).."&password="..urlEncode(SMS.plusPass).."&x=0&y=0";
	if not HttpSendRequest(hRequest, "Content-Type: application/x-www-form-urlencoded", data) then
		err = GetLastError();
		setInfo("Bd: "..err);
		return;
	end;
	txt = InternetReadFile(hRequest);
	if (DEBUG) then plik=io.open("temp\\plus_login.txt" , "wt"); if (plik) then plik:write(txt); plik:close(plik); end; end;
	arrLCode = {};
	if (preg_match("/\[errorsAry\.length\] = \'([^\']+)\';/", txt, arrLCode)) then
		if (arrLCode[1] == "Podaj login!") then setError("Podaj login!"); return; end;
		if (arrLCode[1] == "Podaj haso!") then setError("Podaj haso!"); return; end;
		if (arrLCode[1] == "Podane haso jest nieprawidowe. Uwaga, wielko liter ma znaczenie.") then setError("Podane haso jest nieprawidowe. Wielko liter w hale ma znaczenie!"); return; end;
	end;
	setInfo("Zalogowano poprawnie!");
	InternetCloseHandle(hRequest);

	--- Odwiedzenie strony /sms/send_sms.jsp
	hRequest = HttpOpenRequest(hConnect, "GET", "/sms/send_sms.jsp", "");
	HttpSendRequest(hRequest, "", "");
	InternetCloseHandle(hRequest);

	--- wysyanie smsa
	setInfo("Wysyam SMS'a...");
	hRequest = HttpOpenRequest(hConnect, "POST", "/sms/SendSMS2.do", "");
	text = SMS.msg;
	text = urlEncode(text);
	text = preg_replace("#%20#", "+", text);
         data = "smsType=10&phoneNumber="..SMS.to.."&userId=0&groupId=0&message="..text.."&preview=&sendDay="..SMS.plusKiedy.."&sendHour="..SMS.godzina.."&sendMin="..SMS.minuta.."&archiveMessage="..SMS.plusArch.."&flashMessage="..SMS.plusFlash.."&sendMin="..SMS.plusMin.."&sendHour="..SMS.plusHour.."&sendDay="..SMS.plusKiedy.."&validity="..SMS.plusWaz.."&notifyCode="..SMS.plusPowI.."&targetURL=%2Fsms%2Fsend_sms.jsp";
         HttpSendRequest(hRequest, "Content-Type: application/x-www-form-urlencoded", data) 
	txt = InternetReadFile(hRequest);
	if (DEBUG) then plik=io.open("temp\\plus_send.txt" , "wt"); if (plik) then plik:write(txt); plik:close(plik); end; end;

	--- obsuga wynikw
	tabHead = {};
	tabHead[1] = "Komunikat";
	preg_match("#<font color=.#FFFFFF.><b>([^<]+)<\/b><\/font><\/td>#", txt, tabHead);
	if (tabHead[1] ~= "Komunikat") then
		errCode = 1;
		errTab = {};
		setInfo("1");
		preg_match("#<tr><td colspan=\"2\" bgcolor=\"#F4C8B6\">&nbsp;&nbsp;&nbsp;([^<]+)<\/td>#", txt, errTab);
	else
		errCode = 0;
		succTab = {};
		preg_match("#<tr><td colspan=\"2\" bgcolor=\"#F4C8B6\">&nbsp;&nbsp;&nbsp;([^<]+)<\/td>#", txt, succTab);
	end;

	if (errCode == 1) then 
		setError("Bd: "..iso2cp(errTab[1]));

	else
		setSuccess("Serwer zwrci: "..iso2cp(succTab[1]));
	end;

	--- zamknicie pocze
	InternetCloseHandle(hRequest); 
	InternetCloseHandle(hConnect); 
	InternetCloseHandle(hSession); 
end; 

function sendSMS(SMS) 
	if (SMS.plusUser == "" or SMS.plusPass == "") then
		setError("Nie podae loginu albo hasa!");
		return;
	end;
	plus_send(SMS); 
end;
